PyJavaPackage (Jython API documentation)
Date: 2022-09-10

org.python.core

## Class PyJavaPackage

- java.lang.Object
- - org.python.core.PyObject
  - - org.python.core.PyJavaPackage

- All Implemented Interfaces:
    java.io.Serializable, Traverseproc

      public class PyJavaPackage
      extends PyObject
      implements Traverseproc

  A representation of java package.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.python.core.PyObject

      `PyObject.ConversionException`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `PyStringMap` | `__dict__`
    `java.lang.String` | `__file__`
    `PackageManager` | `__mgr__` (Control) package manager whose hierarchy contains this java pkg
    `java.lang.String` | `__name__`
    `PyStringMap` | `clsSet` Its keys are the names of statically known classes.

    - ### Fields inherited from class org.python.core.PyObject

      `gcMonitorGlobal, TYPE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PyJavaPackage(java.lang.String name)`
    `PyJavaPackage(java.lang.String name, PackageManager mgr)`
    `PyJavaPackage(java.lang.String name, PackageManager mgr, java.lang.String jarfile)`
    `PyJavaPackage(java.lang.String name, java.lang.String jarfile)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `PyObject` | `__dir__()` Equivalent to the standard Python __dir__ method.
    `PyObject` | `__findattr_ex__(java.lang.String name)` Attribute lookup hook.
    `void` | `__setattr__(java.lang.String attr, PyObject value)` A variant of the __setattr__ method which accepts a String as the key.
    `PyObject` | `addClass(java.lang.String name, java.lang.Class<?> c)`
    `PyJavaPackage` | `addPackage(java.lang.String name)`
    `PyJavaPackage` | `addPackage(java.lang.String name, java.lang.String jarfile)` From a dotted package name `a.b.c` interpreted relative to this package `t`, ensure that `a` is in the dictionary of `t` and then recursively process the remainder `b.c` relative to `a`, finally returning the `PyJavaPackage(java.lang.String, org.python.core.packagecache.PackageManager, java.lang.String)` of `t.a.b.c`.
    `void` | `addPlaceholders(java.util.Collection<java.lang.String> classes)` Add the classes named to this package, but with only a placeholder value.
    `PyObject` | `fillDir()` Used for 'from xyz import *', dynamically dir pkg filling up __dict__.
    `boolean` | `refersDirectlyTo(PyObject ob)` Optional operation.
    `java.lang.String` | `toString()`
    `int` | `traverse(Visitproc visit, java.lang.Object arg)` Traverses all directly contained `PyObject`s.

    - ### Methods inherited from class org.python.core.PyObject

      `__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delattr__, __delete__, __delitem__, __delitem__, __delslice__, __delslice__, __div__, __divmod__, __ensure_finalizer__, __eq__, __findattr__, __findattr__, __finditem__, __finditem__, __finditem__, __float__, __floordiv__, __format__, __ge__, __get__, __getattr__, __getattr__, __getitem__, __getitem__, __getnewargs__, __getslice__, __getslice__, __gt__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __imul__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __iter__, __iternext__, __itruediv__, __ixor__, __le__, __len__, __long__, __lshift__, __lt__, __mod__, __mul__, __ne__, __neg__, __nonzero__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setitem__, __setitem__, __setitem__, __setslice__, __setslice__, __str__, __sub__, __tojava__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doget, _doget, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delDict, delType, dispatch__init__, equals, fastGetClass, fastGetDict, getDict, getType, hashCode, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isCallable, isDataDescr, isIndex, isInteger, isMappingType, isNumberType, isSequenceType, noAttributeError, object___subclasshook__, readonlyAttributeError, setDict, setType`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __name__

          public java.lang.String __name__

    - #### __dict__

          public PyStringMap __dict__

    - #### clsSet

          public PyStringMap clsSet

      Its keys are the names of statically known classes. E.g. from jars pre-scan.

    - #### __file__

          public java.lang.String __file__

    - #### __mgr__

          public PackageManager __mgr__

      (Control) package manager whose hierarchy contains this java pkg

  - ### Constructor Detail

    - #### PyJavaPackage

          public PyJavaPackage(java.lang.String name)

    - #### PyJavaPackage

          public PyJavaPackage(java.lang.String name,
                               java.lang.String jarfile)

    - #### PyJavaPackage

          public PyJavaPackage(java.lang.String name,
                               PackageManager mgr)

    - #### PyJavaPackage

          public PyJavaPackage(java.lang.String name,
                               PackageManager mgr,
                               java.lang.String jarfile)

  - ### Method Detail

    - #### addPackage

          public PyJavaPackage addPackage(java.lang.String name)

    - #### addPackage

          public PyJavaPackage addPackage(java.lang.String name,
                                          java.lang.String jarfile)

      From a dotted package name `a.b.c` interpreted relative to this package `t`, ensure that `a` is in the dictionary of `t` and then recursively process the remainder `b.c` relative to `a`, finally returning the `PyJavaPackage(java.lang.String, org.python.core.packagecache.PackageManager, java.lang.String)` of `t.a.b.c`. In the case where the initial package name is just `a`, no dots, the method simply ensures `a` is entered in `t`, and returns the `PyJavaPackage` of `t.a`.
      Parameters:
        `name` - a package name
        `jarfile` - becomes the `__file__` attribute
      Returns:
        the `PyJavaPackage` of the package named

    - #### addClass

          public PyObject addClass(java.lang.String name,
                                   java.lang.Class<?> c)

    - #### addPlaceholders

          public void addPlaceholders(java.util.Collection<java.lang.String> classes)

      Add the classes named to this package, but with only a placeholder value. These names are statically known, typically from processing JAR files on the class path.
      Parameters:
        `classes` - the names as strings

    - #### __dir__

          public PyObject __dir__()

      Description copied from class: `PyObject`
      Equivalent to the standard Python __dir__ method.
      Overrides:
        `__dir__` in class `PyObject`
      Returns:
        a list of names defined by this object.

    - #### fillDir

          public PyObject fillDir()

      Used for 'from xyz import *', dynamically dir pkg filling up __dict__. It uses `PackageManager.doDir(org.python.core.PyJavaPackage, boolean, boolean)` implementation furnished by the control package manager with instantiate true. The package manager should load classes with `addClass(java.lang.String, java.lang.Class<?>)` in the package.
      Returns:
        list of member names

    - #### __findattr_ex__

          public PyObject __findattr_ex__(java.lang.String name)

      Description copied from class: `PyObject`
      Attribute lookup hook. If the attribute is not found, null may be returned or a Py.AttributeError can be thrown, whatever is more correct, efficient and/or convenient for the implementing class. Client code should use `PyObject.__getattr__(String)` or `PyObject.__findattr__(String)`. Both methods have a clear policy for failed lookups.
      Overrides:
        `__findattr_ex__` in class `PyObject`
      Returns:
        The looked up value. May return null if the attribute is not found

    - #### __setattr__

          public void __setattr__(java.lang.String attr,
                                  PyObject value)

      Description copied from class: `PyObject`
      A variant of the __setattr__ method which accepts a String as the key. This String must be interned.
      Overrides:
        `__setattr__` in class `PyObject`
      Parameters:
        `attr` - the name whose value will be set - must be an interned string .
        `value` - the value to set this name to
      See Also:
        `PyObject.__setattr__(PyString, PyObject)`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `PyObject`

    - #### traverse

          public int traverse(Visitproc visit,
                              java.lang.Object arg)

      Description copied from interface: `Traverseproc`
      Traverses all directly contained `PyObject`s. Like in CPython, `arg` must be passed unmodified to `visit` as its second parameter. If `Visitproc.visit(PyObject, Object)` returns nonzero, this return value must be returned immediately by traverse. `Visitproc.visit(PyObject, Object)` must not be called with a `null` PyObject-argument.
      Specified by:
        `traverse` in interface `Traverseproc`

    - #### refersDirectlyTo

          public boolean refersDirectlyTo(PyObject ob)

      Description copied from interface: `Traverseproc`
      Optional operation. Should only be implemented if it is more efficient than calling `Traverseproc.traverse(Visitproc, Object)` with a visitproc that just watches out for `ob`. Must return `false` if `ob` is `null`.
      Specified by:
        `refersDirectlyTo` in interface `Traverseproc`

Jython homepage